import webbrowser
from flask import Flask, render_template, request
from transformers import MarianMTModel, MarianTokenizer


app = Flask(__name__)
def translate_english_to_hebrew(text):
    model_name = "Helsinki-NLP/opus-mt-en-he"
    model = MarianMTModel.from_pretrained(model_name)
    tokenizer = MarianTokenizer.from_pretrained(model_name, cache_dir="./my_cache_dir")
    
    input_ids = tokenizer.encode(text, return_tensors="pt")
    translation_ids = model.generate(input_ids)
    translated_text = tokenizer.decode(translation_ids[0], skip_special_tokens=True)
    return translated_text

@app.route('/', methods=['GET', 'POST'])
def index():
    if request.method == 'POST':
        english_text = request.form['english_text']
        translated_text = translate_english_to_hebrew(english_text)
        return render_template('translate.html', translated_text=translated_text)
    return render_template('translate.html', translated_text=None)

if __name__ == '__main__':
    webbrowser.open('http://127.0.0.1:5000/')
    app.run(debug=False)